---
id: roadmap-v2.2
title: v2.2
slug: /roadmap-v2.2/
---

Manager:

- Peer features are configurable. For example, you can make the peer can not be uploaded and can only be downloaded.
- Configure the weight of the scheduling.
- Add clearing P2P task cache.
- Display P2P traffic distribution.
- Peer information display, including CPU, Memory, etc.

Scheduler:

- Provide metadata storage to support file writing and seeding.
- Optimize scheduling algorithm and improve bandwidth utilization in the P2P network.

Client:

- Client written in Rust, reduce CPU usage and Memory usage.
- Supports RDMA for faster network transmission in the P2P network.
  It can better support the loading of AI inference models into memory.
- Supports file writing and seeding, it can be accessed in the P2P cluster without uploading to other storage.
  Helps AI models and AI datasets to be read and written faster in the P2P network.

Others:

- Defines the V2 of the P2P transfer protocol.

Document:

- Restructure the document to make it easier for users to use.
- Enhance the landing page UI.

AI Infrastructure:

- Supports Triton Inference Server to accelerate model distribution, refer to [dragonfly-repository-agent](../operations/integrations/triton-server.md).
- Supports TorchServer to accelerate model distribution, refer to [document](../operations/integrations/torchserve.md).
- Supports HuggingFace to accelerate model distribution and dataset distribution, refer to [document](../operations/integrations/hugging-face.md).
- Supports Git LFS to accelerate file distribution, refer to [document](../operations/integrations/git-lfs.md).
- Supports JuiceFS to accelerate file downloads from object storage, JuiceFS read requests via
  peer proxy and write requests via the default client of object storage.
- Supports Fluid to accelerate model distribution.
- Support AI infrastructure to efficiently distribute models and datasets, and integrated with the AI ecosystem.
